//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Doctor.Tiy & Anya.Bu.."

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  Yellow
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property  indicator_color4  Green 
#property  indicator_color5  Red 
#property  indicator_color6  Red 
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---- indicator buffers
double     MacdBuffer[];
double     F_upper[];
double     F_lower[];
double     L_Close0[];
double     L_Close1[];
double     L_CloseDelta[];
extern double delta =0.0001;

int m=0 ,n;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_LINE);
     
   SetIndexStyle(4,DRAW_LINE);

//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,F_upper);
   SetIndexBuffer(2,F_lower);
   SetIndexBuffer(3,L_CloseDelta);
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit; int Fractal;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
      
   limit=Bars-counted_bars;

   for(int i=0; i<limit; i++)

{    

MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

L_CloseDelta[i-2]=Close[i-2]- Close[m];

   if (MacdBuffer[i-2]>delta && L_CloseDelta[i-2]>0)    
      if (MacdBuffer[i-2]-MacdBuffer[i-4] > 0)
        if (MacdBuffer[i-2]-MacdBuffer[i-3] > 0)
           if (MacdBuffer[i-2]-MacdBuffer[i-1] > 0)
             if (MacdBuffer[i-2]-MacdBuffer[i] > 0) 
             
           {  F_upper[i-2]=0; m=i-2; }
  
   if (MacdBuffer[i-2]<-1*delta && L_CloseDelta[i-2]<0)
       if (MacdBuffer[i-2]-MacdBuffer[i-4] < 0)
        if (MacdBuffer[i-2]-MacdBuffer[i-3] < 0)
          if (MacdBuffer[i-2]-MacdBuffer[i-1] <  0)
            if (MacdBuffer[i-2]-MacdBuffer[i] < 0) 
            
         {   F_lower[i-2]=0; m=i-2; }

}
   return(0);
  }
//+------------------------------------------------------------------+